'- g-log.bas --------------------------------------------------- >>fst'03<< -
'  G-LOG  Version 1.34 *** Grafischer datenLOGger ***
' - yt-Schreiber
' - X- und Y-Achse vom Anwender skalierbar
' - Messwerte werden als Textdatei gespeichert
' - Messgrafik mit Zusatzprogramm "snapshot" (TSR) speicherbar
' Hardware:
' - Metex/Voltcraft/Digitek Digital-Multimeter an COM 1 - COM 4
' - EGA- oder CGA-Grafik (damit auch fr DOS-Handheld Computer geeignet)
'   getestet auf HP LX200, HP Omnigo 700LX, Highscreen Handy Organizer
' - luft (hoffentlich) auf allen PC's mit DOS / Win3.x / Win95
' Software:
' - QBasic / Quick-Basic 4.5 / Basic PDS / Visual-Basic fr DOS
'- V 20031124 -------------------------------- http://www.FrankSteinberg.de -

DEFINT A-Z

DECLARE FUNCTION VCBereich$ (in%())
DECLARE FUNCTION VCZiffer% (Byte1%, Byte2%)
DECLARE FUNCTION VCEinheit$ (in%())
DECLARE FUNCTION VCWert! (in%())
DECLARE FUNCTION XVal! (A$)
DECLARE FUNCTION Datum$ ()
DECLARE FUNCTION Tmr& ()
DECLARE SUB WarteAuf (TT)
DECLARE SUB MessGeraet ()
DECLARE SUB Gitter ()
DECLARE SUB MinMax ()
DECLARE SUB WertInDatei (Einheit$)
DECLARE SUB Zeitmess (T1&)
DECLARE SUB Datenzeile2 (Abbruch)
DECLARE SUB Params (Titel$)
DECLARE SUB SerInit ()
DECLARE SUB Messwert (Bereich$, Einheit$)
DECLARE SUB Dateikopf (Datei$, Titel$, Bereich$, Einheit$)
DECLARE SUB sek2zeit (Seku&, Zeit$, StuMin$, MinSek$)
DECLARE SUB Datenzeile (Abbruch, Bereich$, Einheit$)
DECLARE SUB Gitter2 ()
DECLARE SUB Zufall ()
DECLARE SUB Linien ()
DECLARE SUB Kopfzeile (Bereich$, Einheit$, Titel$)
DECLARE SUB Beschriftung ()
DECLARE SUB Beschriften2 ()
DECLARE SUB EndBild ()
DECLARE SUB SerRestaur ()
DECLARE SUB Dateifuss ()
DECLARE SUB EndeHinweis (Einheit$)
DECLARE SUB GrafikUmben (GrDat)
DECLARE SUB SchnellEnde (GrDat)
DECLARE SUB DatenLoesch (GrDat)
DECLARE SUB TitelZeile ()

DIM SHARED MGeraet       'Messgerte - Typ
DIM SHARED SPort(4)      'I/O Basisadressen von COM 1 - 4
DIM SHARED SerStr$       'Initialisierungs-String fr die ser. Schnittstelle
DIM SHARED Seku&         'aktuelle Laufzeit in Sekunden
DIM SHARED Zeit$         'aktuelle Laufzeit im ForMat Std:Min:Sek
DIM SHARED UhrZeit$      'aktuelle Uhrzeit
DIM SHARED ZBasis$       'Kennzeichen, ob Uhrzeit auf X-Achse
DIM SHARED MessInterv    'MessIntervall in Sekunden
DIM SHARED FlipFlop      'wechselt pro Sek zwischen 0 und -1
DIM SHARED Messp&        'Anzahl MessPunkte in Werte1!
DIM SHARED ASek&         'Aufzeichnungsdauer in Sekunden
DIM SHARED XMax&         'Maximalwert der X-Achse (Zeit) in Sekunden
DIM SHARED YMax!         'Maximalwert der Y-Achse (Messwerte)
DIM SHARED YMin!         'Minimalwert der Y-Achse (Messwerte)
DIM SHARED Wert!         'Messwert
DIM SHARED LetztWert!    'letzter aufgezeichneter Messwert
DIM SHARED MinWert!      'Minimal-Messwert
DIM SHARED MaxWert!      'Maximal-Messwert
DIM SHARED DWert!        'Durchschnittswert
DIM SHARED T1&           'Startzeit (Sek seit Mitternacht)
DIM SHARED MinSek&       'Zeitpunkt vom Minimal-Messwert in Sekunden
DIM SHARED MaxSek&       'Zeitpunkt vom Maximal-Messwert in Sekunden
DIM SHARED MinZeit$      'Zeitpunkt vom Minimal-Messwert
DIM SHARED MaxZeit$      'Zeitpunkt vom Maximal-Messwert
DIM SHARED MinDatum$     'Datum vom Minimal-Messwert
DIM SHARED MaxDatum$     'Datum vom Maximal-Messwert
DIM SHARED Taste$        'Zuletzt gedrckte Taste$
DIM SHARED Datei$        'Name der Messdatendatei
DIM SHARED Abbruch       'Kennziffer fr Benutzereingaben

'----------------------------------------------------------------------------
'*** Variablen vorbelegen
MinZeit$ = "--:--:--"
MaxZeit$ = "--:--:--"
MessInterv = 1
ASek& = 60
YMax! = 4
YMin! = 0
MGeraet = 9

'----------------------------------------------------------------------------
'*** Schnittstelle und Programmparameter abfragen
Parameter:
CLS
CALL Params(Titel$)
MessG:
CALL MessGeraet
IF MGeraet = 99 THEN GOTO Parameter

IF MGeraet <> 9 THEN CALL SerInit
IF SerStr$ = "Z" THEN GOTO MessG
IF MGeraet <> 9 THEN PRINT #1, "D";
Taste$ = ""

'----------------------------------------------------------------------------
'*** Auf erste Daten warten
CLS
LOCATE 12, 12
PRINT "***  Warte auf Daten;    zurck = [z]     Ende = [e]    ***"
ON ERROR GOTO Fehler2

DO
 CALL Messwert(Bereich$, Einheit$)
 IF Taste$ = "Z" THEN CALL SerRestaur: GOTO MessG
 IF Taste$ = CHR$(27) OR Taste$ = "E" THEN CALL SchnellEnde(GrDat)
LOOP UNTIL LEN(Einheit$) > 0

'----------------------------------------------------------------------------
'*** Grafik-Bildschirm aufbauen mit Starthinweis
ON ERROR GOTO CGA               'automatische Prfung, ob EGA 640x350 mglich
 SCREEN 9
 Grafik = 350
 VIEW (39, 14)-(639, 307), 10
GOTO EndeGrafik
CGA:                            'bei Fehler CGA-Modus
 SCREEN 2
 VIEW (39, 8)-(639, 174), 1
 RESUME EndeGrafik
EndeGrafik:

ON ERROR GOTO Fehler2            'alte Fehlerbehandlung wieder herstellen
WINDOW (0, YMin!)-(ASek&, YMax!)
CALL Kopfzeile(Bereich$, Einheit$, Titel$)
CALL Beschriftung
CALL Gitter
LOCATE 11, 26
PRINT "   Aufzeichnung starten = [Enter]   "
LOCATE 12, 26
PRINT "   zurck = [z]        Ende = [e]   "
Taste$ = ""
DO
 CALL WarteAuf(0)
 CALL Messwert(Bereich$, Einheit$)
 CALL Datenzeile(Abbruch, Bereich$, Einheit$)
 IF Taste$ = CHR$(27) OR Taste$ = "E" THEN CALL SchnellEnde(GrDat)
 IF Taste$ = CHR$(13) THEN EXIT DO
 IF Taste$ = "Z" THEN SCREEN 0: CALL SerRestaur: GOTO MessG
 CALL WarteAuf(6)
LOOP

'----------------------------------------------------------------------------
' *** Starthinweis lschen und Aufzeichnung starten
SOUND 4000, 1
CLS
IF Grafik = 350 THEN VIEW (39, 14)-(639, 307), 10 ELSE VIEW (39, 8)-(639, 174), 1
CALL Gitter
WINDOW (0, YMin!)-(ASek&, YMax!)
CALL Dateikopf(Datei$, Titel$, Bereich$, Einheit$)

T1& = Tmr&      'Startzeit speichern
IF ZBasis$ = "U" THEN CALL Beschriften2

'============================================================================
' *** Hauptschleife
'============================================================================

DO

Daten:

 Taste$ = ""

 ON ERROR GOTO Fehler                         'Fehler abfangen
 IF SekuAlt& < Seku& THEN
  FlipFlop = -1 - FlipFlop
  CALL Messwert(Bereich$, Einheit$)
  IF Seku& MOD 21600 = 0 THEN                 'Datei alle 6 Std (21600 Sek)
   CLOSE #2                                   'auf Disk speichern
   OPEN Datei$ FOR APPEND AS #2
  END IF
 END IF
 SekuAlt& = Seku&
 ON ERROR GOTO 0                              'Fehlermeldung wieder aktivieren

 CALL Zeitmess(T1&)                           'Laufzeit (Seku&) messen
 CALL sek2zeit(Seku&, Zeit$, X$, Y$)          'Zeit-String erzeugen

 CALL Datenzeile(Abbruch, Bereich$, Einheit$) 'Datenzeilen schreiben

 '*** Wenn Zeit fr neue Messung erreicht oder erste Messung
 IF Seku& >= Messp& * MessInterv THEN
  CALL MinMax                                 'Min/Max-Werte speichern
  CALL WertInDatei(Einheit$)                  'Aktuellen Wert in Datei
  CALL Linien                                 'Linie ins Diagramm zeichnen
  LetzteM& = Seku&                            'Zeit letzter Messpunkt speichern
  Messp& = Messp& + 1                         'Messpunkt zhlen
  LetztWert! = Wert!                          'Alten Messwert speichern
 END IF

 IF Seku& = ASek& THEN GOTO Ende              'Messzeit verstrichen
 IF Taste$ = "" THEN Taste$ = UCASE$(INKEY$)
 IF Taste$ = CHR$(27) OR Taste$ = "E" THEN Abbruch = 1: SOUND 4000, 1
 IF Abbruch = 1 THEN CALL Datenzeile2(Abbruch)'Abfrage einblenden
 IF Abbruch = 2 THEN GOTO Ende                'Abfrage = Ja -> beenden

LOOP

'============================================================================
'*** Abschlu des Programms
'============================================================================

Ende:

CALL Dateifuss             'Min/Maxwert in Datei schreiben

CALL EndeHinweis(Einheit$) 'blinkenden Ende-Hinweis schreiben; Anwender hat
                           'die Mglichkeit, die Grafik zu speichern.
CALL GrafikUmben(GrDat)    'mit snapshot.exe erstellte Grafikdatei umbenennen

CALL SchnellEnde(GrDat)

'----------------------------------------------------------------------------
'*** Fehler bei serieller bertragung abfangen
Fehler:
CLOSE #2                                   'Daten auf Disk speichern
OPEN Datei$ FOR APPEND AS #2
OPEN "fehler.txt" FOR APPEND AS #3
PRINT #3, Datum$; " "; TIME$; "; Laufzeit "; Zeit$; "; Fehler Nr"; ERR; "; Gert "; ERDEV$; " (Nr"; ERDEV; ")"
CLOSE #3
CLOSE #1
OPEN SerStr$ FOR RANDOM AS #1
RESUME NEXT

Fehler2:
SOUND 200, 2
CLOSE #1
OPEN SerStr$ FOR RANDOM AS #1
Versuch = Versuch + 1
IF Versuch > 3 THEN ON ERROR GOTO 0  'nach max 3 Fehlern Fehlermeldung ausgeben
RESUME NEXT

FehlerIgnor:
RESUME NEXT

SUB Beschriften2

 Tmp& = T1&
 LOCATE 23, 3: GOSUB Anzeigen: PRINT " Uhr";

 Tmp& = T1& + ASek& * 1 / 6
 LOCATE 23, 16: GOSUB Anzeigen
 Tmp& = T1& + ASek& * 2 / 6
 LOCATE 23, 28: GOSUB Anzeigen
 Tmp& = T1& + ASek& * 3 / 6
 LOCATE 23, 41: GOSUB Anzeigen
 Tmp& = T1& + ASek& * 4 / 6
 LOCATE 23, 53: GOSUB Anzeigen
 Tmp& = T1& + ASek& * 5 / 6
 LOCATE 23, 65: GOSUB Anzeigen
 Tmp& = T1& + ASek& * 6 / 6
 LOCATE 23, 76: GOSUB Anzeigen

EXIT SUB

Anzeigen:
 DO WHILE Tmp& > 86400
  Tmp& = Tmp& - 86400
 LOOP
 CALL sek2zeit(Tmp&, Zeit$, StuMin$, MinSek$)
 PRINT StuMin$;
RETURN

END SUB

SUB Beschriftung

'Beschriftung der Y-Achse

SELECT CASE YMax!     'Platzbedarf des Maximalwerts ermitteln
CASE 1 TO 9.999999
 Stellen = 1
CASE 10 TO 99.99999
 Stellen = 2
CASE ELSE
 Stellen = 3
END SELECT

SELECT CASE YMin!     'fr das Minuszeichen muss eine Stelle geopfert werden
CASE -9.999999 TO -.0000001
 MStellen = 2
CASE -99.99999 TO -10
 MStellen = 3
CASE -999.9999 TO -100
 MStellen = 4
END SELECT

'Den Wert, mit dem grten Platzbedarf ermitteln
IF MStellen > Stellen THEN Stellen = MStellen
'... und danach die PRINT USING Maske bestimmen

SELECT CASE Stellen
CASE 1
 Maske$ = "#.###"
CASE 2
 Maske$ = "##.##"
CASE 3
 Maske$ = "###.#"
CASE ELSE
 Maske$ = "#### "
END SELECT

Zeile = 22
FOR i = 0 TO 10
 LOCATE Zeile, 1
 Zeile = Zeile - 2
 YWert! = (YMax! - YMin!) / 10 * i + YMin!
 PRINT USING Maske$; YWert!
NEXT i

'Beschriftung der X-Achse
 LOCATE 23, 3
 IF ASek& <= 600 THEN PRINT "Min:Sek";  ELSE PRINT "Std:Min";

 Tmp& = ASek& * 1 / 6: LOCATE 23, 16: GOSUB ZeitAnz
 Tmp& = ASek& * 2 / 6: LOCATE 23, 28: GOSUB ZeitAnz
 Tmp& = ASek& * 3 / 6: LOCATE 23, 41: GOSUB ZeitAnz
 Tmp& = ASek& * 4 / 6: LOCATE 23, 53: GOSUB ZeitAnz
 Tmp& = ASek& * 5 / 6: LOCATE 23, 65: GOSUB ZeitAnz
 Tmp& = ASek& * 6 / 6: LOCATE 23, 76: GOSUB ZeitAnz

EXIT SUB

ZeitAnz:
 CALL sek2zeit(Tmp&, Zeit$, StuMin$, MinSek$)
 IF ASek& <= 600 THEN PRINT MinSek$ ELSE PRINT StuMin$
RETURN

WertAnz:

END SUB

SUB Dateifuss
' Min-/Max-Werte in Datendatei schreiben

PRINT #2,
PRINT #2, "; Minimalwert "; STR$(MinWert!); " bei ";
IF ZBasis$ = "U" THEN PRINT #2, MinDatum$ + "  " + MinZeit$ ELSE PRINT #2, MinSek&; "Sekunden"
PRINT #2, "; Maximalwert "; STR$(MaxWert!); " bei ";
IF ZBasis$ = "U" THEN PRINT #2, MaxDatum$ + "  " + MaxZeit$ ELSE PRINT #2, MaxSek&; "Sekunden"
PRINT #2, "; Mittelwert  "; STR$(DWert!);

END SUB

DEFSNG A-Z
SUB Dateikopf (Datei$, Titel$, Bereich$, Einheit$)

'Dateiname erzeugen aus Monat, Tag, Stunde, Minute + ".txt"
Datei$ = LEFT$(DATE$, 2) + MID$(DATE$, 4, 2) + LEFT$(TIME$, 2) + MID$(TIME$, 4, 2) + ".txt"

OPEN Datei$ FOR OUTPUT AS #2 LEN = 8192

PRINT #2, "; Messdaten-Datei des Programms G-Log 1.34; angelegt " + Datum$ + ", " + TIME$ + " Uhr"
PRINT #2,
PRINT #2, "; "; Titel$
PRINT #2,
IF ZBasis$ = "U" THEN PRINT #2, ";Zeit" + CHR$(9);  ELSE PRINT #2, ";Sek.";
PRINT #2, CHR$(9); " "; Bereich$; "("; Einheit$; ")"
PRINT #2,

END SUB

DEFINT A-Z
SUB DatenLoesch (GrDat)

SCREEN 0
PRINT

IF Datei$ = "" THEN EXIT SUB

CLOSE #2

IF GrDat <> 1 THEN PRINT " Datendatei >>"; Datei$; "<< lschen ?   "
IF GrDat THEN PRINT " Datendatei >>"; Datei$; "<< und Grafikdatei >>"; LEFT$(Datei$, 8); ".exe<< lschen ?"
PRINT
PRINT " [J]a / [N]ein"

DO
 Taste$ = INPUT$(1)
LOOP UNTIL UCASE$(Taste$) = "J" OR UCASE$(Taste$) = "N"

IF UCASE$(Taste$) = "J" THEN
 PRINT
 PRINT " Lsche: "; Datei$
 KILL Datei$
 IF GrDat THEN PRINT " Lsche: "; LEFT$(Datei$, 8); ".exe"
 IF GrDat THEN KILL LEFT$(Datei$, 8) + ".exe"
 SLEEP 1
END IF

END SUB

SUB Datenzeile (Abbruch, Bereich$, Einheit$)
LOCATE 24, 1
 PRINT "Aktuell " + Bereich$;
 PRINT USING "#####.###"; Wert!;
 PRINT Einheit$;
 IF FlipFlop THEN
   PRINT USING "  Max####.###"; MaxWert!;
   PRINT Einheit$ + " bei " + MaxZeit$;
  ELSE
   PRINT USING "  Min####.###"; MinWert!;
   PRINT Einheit$ + " bei " + MinZeit$;
 END IF
 IF ZBasis$ = "U" THEN
   PRINT "  "; Datum$; "  "; TIME$; " Uhr";
  ELSE
   PRINT "  Laufz "; Zeit$; " "; LEFT$(TIME$, 5); " Uhr";
 END IF

LOCATE 25, 1
 PRINT USING "Letzte Aufz ####.###"; LetztWert!;
 PRINT Einheit$;
 PRINT USING "  Mit####.###"; DWert!;
 PRINT Einheit$ + " (Mittelwert)";
 IF Abbruch < 1 THEN PRINT USING "  Aufz####### in###### Sek"; Messp&; Messp& * MessInterv - Seku&;

END SUB

SUB Datenzeile2 (Abbruch)

LOCATE 25, 56
IF FlipFlop THEN
  PRINT " BEENDEN ?  [J]a / [N]ein";
 ELSE
  PRINT "                         ";
END IF

IF UCASE$(Taste$) = "N" THEN Abbruch = 0: SOUND 4000, 1 'Abfrage nicht mehr einblenden
IF UCASE$(Taste$) = "J" THEN Abbruch = 2   'Aufzeichnung endgltig beenden

END SUB

FUNCTION Datum$

'Deutsches Datumsformat mit vierstelliger Jahreszahl erzeugen
Datum$ = MID$(DATE$, 4, 2) + "-" + LEFT$(DATE$, 2) + "-" + RIGHT$(DATE$, 4)

END FUNCTION

SUB EndBild
CLS
PRINT
COLOR 0, 7
PRINT " G-Log 1.34  beendet       "; Datum$; ",  "; TIME$; " Uhr                   fst'03 ";
PRINT " INTERNET:        http://www.FrankSteinberg.de                                  ";
COLOR 7, 0
PRINT
PRINT
SYSTEM

END SUB

SUB EndeHinweis (Einheit$)
' blinkenden Ende-Hinweis erzeugen

SOUND 4000, 1

LOCATE 24, 27
 PRINT USING "Max####.###"; MaxWert!;
 PRINT Einheit$ + " bei " + MaxZeit$;

LOCATE 25, 1
 PRINT USING "Mittelwert  ####.###"; DWert!;
 PRINT Einheit$;
 PRINT USING "  Min####.###"; MinWert!;
 PRINT Einheit$ + " bei " + MinZeit$;

DO WHILE Taste$ <> CHR$(27) AND Taste$ <> "E"
 LOCATE 25, 56
 PRINT " Tabelle sichern: [Druck]";
 SLEEP 1
 LOCATE 25, 56
 PRINT " Programm beenden:  [e]  ";
 SLEEP 1
 Taste$ = UCASE$(INKEY$)
LOOP

SOUND 4000, 1

END SUB

SUB Gitter

WINDOW (0, 0)-(12, 10)

'senkrechte Gitterlinien zeichnen
FOR X = 1 TO 11
  LINE (X, 0)-(X, 10), 0, , &H8888
NEXT X

'wagerechte Gitterlinien zeichnen
FOR Y = 1 TO 9
  LINE (0, Y)-(12, Y), 0, , &H101
NEXT Y

END SUB

SUB GrafikUmben (GrDat)
' Wenn Grafikdatei erzeugt wurde; wie Datendatei benennen

OPEN "bild0.exe" FOR BINARY AS #3
IF LOF(3) THEN
  CLOSE #3
  NAME "bild0.exe" AS LEFT$(Datei$, 8) + ".exe"
  GrDat = 1
 ELSE
  CLOSE #3
  KILL "bild0.exe"
END IF

END SUB

SUB Kopfzeile (Bereich$, Einheit$, Titel$)

EinheitY1$ = LEFT$(Bereich$, 2) + "(" + RIGHT$(Einheit$, 2) + ")"

IF LEN(Titel$) < 60 THEN
 Tmp = (68 - LEN(Titel$)) \ 2
 Fuellz$ = SPACE$(Tmp)
END IF

LOCATE 1, 1
PRINT EinheitY1$
LOCATE 1, 10
PRINT Fuellz$ + Titel$;

END SUB

SUB Linien

'Linie zum neuen Messpunkt zeichnen
IF Messp& = 0 THEN
 PSET (0, Wert!), 0
ELSE
 LINE -(Seku&, Wert!), 0
END IF


END SUB

SUB MessGeraet

CALL TitelZeile   'Titelzeile schreiben

' ____________________________________________________________________________
' *** Bildschirm fr die Messgerte - Auswahl schreiben

LOCATE 5, 1
PRINT " Bitte Messgert - Typ whlen :"
PRINT " ------------------------------"
PRINT " Metex Digital-Multimeter (DMM)  600 Baud  z.B. Metex ME-32       ->  Taste [1]"
PRINT " Metex Digital-Multimeter (DMM) 1200 Baud  z.B. Metex 3850        ->  Taste [2]"
PRINT " Metex Digital-Multimeter (DMM) 9600 Baud  z.B. Metex 3860   *    ->  Taste [3]"
PRINT " Voltcraft VC820/VC840, Digitek DT9062/DT4000ZC                   ->  Taste [4]"
PRINT " Simulationsmodus mit Zufallszahlen; kein Messgert erforderlich  ->  [ Enter ]"
PRINT
PRINT " * =  nicht mit allen Rechnern mglich"

DO
 Taste$ = UCASE$(INPUT$(1))
 IF Taste$ = CHR$(27) OR Taste$ = "E" THEN CALL EndBild
 IF Taste$ = CHR$(13) THEN Taste$ = "9"
 IF Taste$ = "Z" THEN Taste$ = "99"
 MGeraet = VAL(Taste$)
LOOP UNTIL MGeraet > 0 AND MGeraet < 5 OR MGeraet = 9 OR MGeraet = 99

PRINT "                                                         gewhlt  =>        "; MGeraet
PRINT
PRINT
PRINT

END SUB

SUB Messwert (Bereich$, Einheit$)

STATIC C$      'String aus vorheriger Messung

SELECT CASE MGeraet

'---------------------------------------------------------------------------
CASE 1, 2, 4  '*** Metex DMM 600 & 1200 Baud und VC8xx/Digitek

 IF LOC(1) > 14 THEN      'ueberzaehlige Zeichen aus Puffer entfernen
  DO
   A$ = INPUT$(1, 1#)
  LOOP UNTIL LOC(1) < 15
 END IF

'---------------------------------------------------------------------------
CASE 3   '*** Metex DMM 9600 Baud

 IF LOC(1) > 56 THEN      'ueberzaehlige Zeichen aus Puffer entfernen
  DO
   A$ = INPUT$(1, 1#)
  LOOP UNTIL LOC(1) < 57
 END IF

END SELECT

SELECT CASE MGeraet

'---------------------------------------------------------------------------
CASE 1 TO 3   '*** Alle Metex DMM

Wert:

 b$ = ""
 TSer& = Tmr&                               'Timer fr Zeitberwachung
 DO
  GOSUB holTaste
  IF LOC(1) THEN
   A$ = INPUT$(1, #1)
   b$ = b$ + A$
  END IF
  IF Taste$ = CHR$(27) OR Taste$ = "E" THEN GOTO SubEnde
  IF Tmr& - TSer& > 1 THEN
   PRINT #1, "D";
   GOTO SubEnde     'Abbruch, wenn ber 1 Sek kein Zeichen
  END IF
 LOOP UNTIL A$ = CHR$(13)

 CALL WarteAuf(0)   'Wartetimer initialisieren

 'Messwert nur nehmen, wenn max. 14 Zeichen; sonst alten Wert
 IF LEN(b$) > 13 THEN b$ = RIGHT$(b$, 14) ELSE b$ = C$
 C$ = b$
 
 'String zerlegen
 Bereich$ = LEFT$(b$, 3)
 Zahl$ = MID$(b$, 4, 6)
 Einheit$ = MID$(b$, 11, 3)

 'Messwert nur nehmen, wenn dort eine Einheit steht; damit sollen die
 'Werte der Unterdisplays (9600 Baud-Modelle) ausgefiltert werden
 IF Bereich$ = "   " THEN GOTO Wert
 IF Einheit$ = "   " THEN GOTO Wert

 CALL WarteAuf(3)   '3 Timer-Tics seit "WarteAuf(0)" warten
 PRINT #1, "D";     'einige DMM brauchen etwas Zeit nach der Datenbertragung

 'Messwert auf unerlaubte Zeichen absuchen:
 Erlaubt$ = "0123456789 .-"
 FOR i = 1 TO 6
  IF INSTR(Erlaubt$, MID$(Zahl$, i, 1)) = 0 THEN GOTO Wert
 NEXT i

 Wert! = VAL(Zahl$)

'---------------------------------------------------------------------------
CASE 4  '*** VC8xx und Digitek

 DIM in%(1 TO 14)       'Datenfeld fuer 14 Bytes einrichten
                        '(das DMM sendet 14 Bytes je Messung)

VCMess:

 TSer& = Tmr&           'Timer fr Zeitueberwachung

 DO                     'Byte 1 suchen
  IF LOC(1) THEN
   A$ = INPUT$(1, #1)   'ein Zeichen einlesen
   in%(1) = ASC(A$)     'Ascii-Wert des Zeichens
   Test = in%(1) \ 16   'hoeherwertiges Nibble isolieren
  END IF
  GOSUB holTaste        'auf Tastendruck pruefen
  IF Taste$ = CHR$(27) OR Taste$ = "E" THEN GOTO SubEnde
  IF Tmr& - TSer& > 1 THEN GOTO SubEnde  'Abbruch, wenn ber 1 Sek kein Zeichen
 LOOP UNTIL Test = 1    'wiederholen, wenn nicht Byte 1

 DO                     'auf weitere 13 Zeichen warten
  GOSUB holTaste        'auf Tastendruck pruefen
  IF Taste$ = CHR$(27) OR Taste$ = "E" THEN GOTO SubEnde
  IF Tmr& - TSer& > 1 THEN GOTO SubEnde  'Abbruch, wenn ber 1 Sek kein Zeichen
 LOOP WHILE LOC(1) < 13

 FOR i = 2 TO 14        'Byte 2 - 14 holen
  A$ = INPUT$(1, #1)
  in%(i) = ASC(A$)      'Ascii-Wert des Zeichens
 NEXT

 Tmp! = VCWert!(in%())             'Messwert mit FUNCTION VCWert! bestimmen
 IF Tmp! = 9999 THEN GOTO VCMess   '9999=ungueltiger Messwert, nochmal messen
 Wert! = Tmp!                      'Wert iO, bei Zeitueberlauf bleibt alter Wert!
 Bereich$ = VCBereich$(in%())      'Messbereich (AC/DC) bestimmen
 Einheit$ = VCEinheit$(in%())      'Mess-Einheit bestimmen

'---------------------------------------------------------------------------
CASE 9  '*** Simulationsmodus

 Spannw! = YMax! - YMin!
 Spannw! = Spannw! / 3
 Wert! = RND * Spannw! + YMin! + Spannw!
 Bereich$ = "Sim"
 Einheit$ = " V "
 GOSUB holTaste

END SELECT

GOTO SubEnde

holTaste:
 Taste$ = UCASE$(Taste$)
 IF Taste$ = CHR$(13) THEN RETURN
 IF Taste$ = CHR$(27) THEN RETURN
 IF Taste$ = "Z" THEN RETURN
 IF Taste$ = "E" THEN RETURN
 IF Taste$ = "J" AND Abbruch = 1 THEN EXIT SUB
 Taste$ = INKEY$
RETURN

SubEnde:
END SUB

SUB MinMax

'Minimal- und Maximalwerte speichern

IF Messp& = 0 THEN
 MinWert! = Wert!
 MaxWert! = Wert!
 MaxSek& = Seku&
 MinSek& = Seku&
 IF ZBasis$ = "U" THEN
  MinZeit$ = UhrZeit$
  MaxZeit$ = UhrZeit$
  MinDatum$ = Datum$
  MaxDatum$ = Datum$
 ELSE
  MinZeit$ = Zeit$
  MaxZeit$ = Zeit$
 END IF
END IF

IF Wert! < MinWert! THEN
 MinWert! = Wert!
 IF ZBasis$ = "U" THEN
  MinZeit$ = UhrZeit$
  MinDatum$ = Datum$
 ELSE MinZeit$ = Zeit$
 END IF
 MinSek& = Seku&
END IF

IF Wert! > MaxWert! THEN
 MaxWert! = Wert!
 IF ZBasis$ = "U" THEN
  MaxZeit$ = UhrZeit$
  MaxDatum$ = Datum$
 ELSE MaxZeit$ = Zeit$
 END IF
 MaxSek& = Seku&
END IF

'Mittelwert errechnen
STATIC DSumme!
DSumme! = DSumme! + Wert!
DWert! = DSumme! / (Messp& + 1)

END SUB

SUB Params (Titel$)

'Programmparameter abfragen

CALL TitelZeile

Lz:
LOCATE 5, 1
PRINT " Bitte Laufzeit in Min eingeben (X-Achse); mit [Enter] abschlieen"
PRINT SPACE$(80);
LOCATE , 1
LINE INPUT " > ", T$
IF T$ = "" THEN T$ = "1"
IF UCASE$(T$) = "E" THEN CALL EndBild
ASek& = VAL(T$)
IF ASek& < 1 OR ASek& > 527040 THEN GOTO Lz
LOCATE 6, 3
PRINT ASek&; SPACE$(78 - POS(0))
ASek& = ASek& * 60

MinWert:
LOCATE 8, 1
PRINT " Bitte MINIMALwert der Y-Achse (Messwerte) eingeben; mit [Enter] abschlieen"
PRINT SPACE$(80);
LOCATE , 1
LINE INPUT " > ", T$
IF UCASE$(T$) = "E" THEN CALL EndBild
IF UCASE$(T$) = "Z" THEN GOTO Lz
YMin! = XVal!(T$)
IF YMin! > 998 THEN GOTO MinWert
LOCATE 9, 3
PRINT YMin!; SPACE$(78 - POS(0))

MaxWert:
LOCATE 11, 1
PRINT " Bitte MAXIMALwert der Y-Achse (Messwerte) eingeben; mit [Enter] abschlieen"
PRINT SPACE$(80);
LOCATE , 1
LINE INPUT " > ", T$
IF T$ = "" THEN T$ = "20"
IF UCASE$(T$) = "E" THEN CALL EndBild
IF UCASE$(T$) = "Z" THEN GOTO MinWert
YMax! = XVal!(T$)
IF YMax! <= YMin! OR YMax! > 999 THEN GOTO MaxWert
LOCATE 12, 3
PRINT YMax!; SPACE$(78 - POS(0))

MessIntervall:
LOCATE 14, 1
PRINT " Bitte Aufzeichnungsintervall in Sekunden (max. 32767) eingeben; keine Eingabe"
PRINT " fr automatische Berechnung (max. 600 Messwerte); mit [Enter] abschlieen"
PRINT SPACE$(80);
LOCATE , 1
LINE INPUT " > ", T$
IF UCASE$(T$) = "E" THEN CALL EndBild
IF UCASE$(T$) = "Z" THEN GOTO MaxWert
MessInterv = VAL(T$)
LOCATE 16, 3
PRINT MessInterv; SPACE$(78 - POS(0))
IF MessInterv < 0 OR MessInterv > ASek& THEN GOTO MessIntervall
LOCATE 16, 4
IF MessInterv = 0 THEN PRINT "auto";

'Messintervall so dimensionieren, dass max 600 Messwerte
'aufgezeichnet werden (Auflsung)
IF MessInterv = 0 THEN MessInterv = (ASek& - 1) \ 600 + 1

Zeitbasis:
LOCATE 18, 1
PRINT " Zeitbasis (X-Achse) bestimmen: U fr Uhrzeit; andere Eingabe fr Laufzeit"
PRINT SPACE$(80);
LOCATE , 1
PRINT " > ";
ZBasis$ = UCASE$(INPUT$(1))
IF ZBasis$ = "E" THEN CALL EndBild
IF ZBasis$ = "Z" THEN GOTO MessIntervall
IF ZBasis$ = "U" THEN PRINT "Uhrzeit" ELSE PRINT "Laufzeit"

LOCATE 21, 1
PRINT " Bitte Titel der Messreihe eingeben; mit [Enter] abschlieen"
PRINT SPACE$(80);
LOCATE , 1
PRINT " > ";
LINE INPUT Titel$
IF UCASE$(Titel$) = "E" THEN CALL EndBild
IF UCASE$(Titel$) = "Z" THEN GOTO Zeitbasis
IF Titel$ = "" THEN Titel$ = " G-Log 1.34 * Grafischer Datenlogger * Public Domain * fst'03"


END SUB

SUB SchnellEnde (GrDat)

CLOSE #1

CALL SerRestaur         'I/O-Adresse der ser. Schnittstellen restaurier
CALL DatenLoesch(GrDat) 'Abfrage; Datendateien lschen
CALL EndBild            'Abschlubidschirm und Schlu Aus Ende

END SUB

SUB sek2zeit (Seku&, Zeit$, StuMin$, MinSek$)

'aus Sekunden -> Stunden:Minuten:Sekunden machen

Stunden& = Seku& \ 3600
RestSeku& = Seku& - Stunden& * 3600
Minuten = RestSeku& \ 60
RestSeku& = RestSeku& - Minuten * 60
Sekunden = RestSeku&

'String erzeugen
'fhrende Nullen und Doppelpunkt ergnzen
IF Stunden& > 9 THEN
  Zeit$ = RIGHT$(STR$(Stunden&), 2)
 ELSE
  Zeit$ = "0" + RIGHT$(STR$(Stunden&), 1)
END IF
 Zeit$ = Zeit$ + ":"
IF Minuten > 9 THEN
  Zeit$ = Zeit$ + RIGHT$(STR$(Minuten), 2)
 ELSE
  Zeit$ = Zeit$ + "0" + RIGHT$(STR$(Minuten), 1)
END IF
 Zeit$ = Zeit$ + ":"
IF Sekunden > 9 THEN
  Zeit$ = Zeit$ + RIGHT$(STR$(Sekunden), 2)
 ELSE
  Zeit$ = Zeit$ + "0" + RIGHT$(STR$(Sekunden), 1)

END IF

StuMin$ = LEFT$(Zeit$, 5)
MinSek$ = RIGHT$(Zeit$, 5)

END SUB

SUB SerInit

' *** Adressen COM 1 - 4 einlesen

DEF SEG = 0

SPort(1) = PEEK(&H400) + 256 * PEEK(&H401)
SPort(2) = PEEK(&H402) + 256 * PEEK(&H403)
SPort(3) = PEEK(&H404) + 256 * PEEK(&H405)
SPort(4) = PEEK(&H406) + 256 * PEEK(&H407)

' *** Bildschirm fr die COM - Port - Auswahl schreiben

ComTest:

PRINT " Bitte seriellen Port whlen :"
PRINT " -----------------------------"
 
IF SPort(1) > 0 THEN
  PRINT " COM 1       (bei "; SPort(1); " Dez / "; HEX$(SPort(1)); " Hex)                           ->  Taste [1]"
 ELSE
  PRINT " COM 1      * steht nicht zur Verfgung *"
END IF

IF SPort(2) > 0 THEN
  PRINT " COM 2       (bei "; SPort(2); " Dez / "; HEX$(SPort(2)); " Hex)                            ->  Taste [2]"
 ELSE
  PRINT " COM 2      * steht nicht zur Verfgung *"
END IF

IF SPort(3) > 0 THEN
  PRINT " COM 3       (bei "; SPort(3); " Dez / "; HEX$(SPort(3)); " Hex)                           ->  Taste [3]"
 ELSE
  PRINT " COM 3      * steht nicht zur Verfgung *"
END IF

IF SPort(4) > 0 THEN
  PRINT " COM 4       (bei "; SPort(4); " Dez / "; HEX$(SPort(4)); " Hex)                            ->  Taste [4]"
 ELSE
  PRINT " COM 4      * steht nicht zur Verfgung *"
END IF

ComTaste:

Taste$ = UCASE$(INPUT$(1))

' *** berprfung, ob Anschlu vorhanden
 
SELECT CASE Taste$
CASE IS = CHR$(27)
  CALL EndBild
CASE IS = "E"
  CALL EndBild
CASE IS = "Z"
  SerStr$ = "Z"
  EXIT SUB
CASE IS = "1"
  IF SPort(1) <= 0 THEN GOTO ComTaste
CASE IS = "2"
  IF SPort(2) <= 0 THEN GOTO ComTaste
CASE IS = "3"
  IF SPort(3) <= 0 THEN GOTO ComTaste
  POKE &H400, SPort(3) MOD 256        'I/O Adressen COM 3 - COM 1 tauschen
  POKE &H401, SPort(3) \ 256
  POKE &H404, SPort(1) MOD 256
  POKE &H405, SPort(1) \ 256
CASE IS = "4"
  IF SPort(4) <= 0 THEN GOTO ComTaste
  POKE &H402, SPort(4) MOD 256         'I/O Adressen COM 4 - COM 2 tauschen
  POKE &H403, SPort(4) \ 256
  POKE &H406, SPort(2) MOD 256
  POKE &H407, SPort(2) \ 256
CASE ELSE
  GOTO ComTaste
END SELECT


' *** Initialisierungsstring abhngig von Schnittstelle/Messgert erzeugen

SELECT CASE MGeraet
 CASE 1
  IF Taste$ = "1" OR Taste$ = "3" THEN SerStr$ = "COM1:600,N,7,2,RS,CS,DS,CD"
  IF Taste$ = "2" OR Taste$ = "4" THEN SerStr$ = "COM2:600,N,7,2,RS,CS,DS,CD"
 CASE 2
  IF Taste$ = "1" OR Taste$ = "3" THEN SerStr$ = "COM1:1200,N,7,2,RS,CS,DS,CD"
  IF Taste$ = "2" OR Taste$ = "4" THEN SerStr$ = "COM2:1200,N,7,2,RS,CS,DS,CD"
 CASE 3
  IF Taste$ = "1" OR Taste$ = "3" THEN SerStr$ = "COM1:9600,N,7,2,RS,CS,DS,CD"
  IF Taste$ = "2" OR Taste$ = "4" THEN SerStr$ = "COM2:9600,N,7,2,RS,CS,DS,CD"
 CASE 4
  IF Taste$ = "1" OR Taste$ = "3" THEN SerStr$ = "COM1:2400,N,8,1,RS,CS,DS,CD"
  IF Taste$ = "2" OR Taste$ = "4" THEN SerStr$ = "COM2:2400,N,8,1,RS,CS,DS,CD"
END SELECT

' *** Serielle Schnittstelle ffnen

 IF Taste$ <> "" THEN OPEN SerStr$ FOR RANDOM AS #1


END SUB

SUB SerRestaur
'Adressen von COM 1 & 2 restaurieren

IF SPort(1) THEN POKE &H400, SPort(1) MOD 256: POKE &H401, SPort(1) \ 256
IF SPort(2) THEN POKE &H402, SPort(2) MOD 256: POKE &H403, SPort(2) \ 256
IF SPort(3) THEN POKE &H404, SPort(3) MOD 256: POKE &H405, SPort(3) \ 256
IF SPort(4) THEN POKE &H406, SPort(4) MOD 256: POKE &H407, SPort(4) \ 256

END SUB

SUB TitelZeile

CLS
PRINT
COLOR 0, 7
PRINT " >>  G-Log 1.34 - Grafischer Multimeter Datenlogger  <<                fst'03 ";
PRINT "         zurck = [z]                Ende = [e]                                 ";
COLOR 7, 0

END SUB

FUNCTION Tmr&
'Sekunden seit Mitternacht ausgeben
' bei Rechnern mit Power-Management (Handy-Organizer) funktioniert
' bei lngerer Programm-Inaktivitt die Basic-eigene TIMER-Funktion
' nicht zuverlssig.

 DEF SEG = 0
  C = PEEK(&H46C)
  D& = PEEK(&H46D)
  E& = PEEK(&H46E)
  Tmp& = C + D& * 256 + E& * 65536
  Tmr& = Tmp& / 18.2065

END FUNCTION

FUNCTION VCBereich$ (in%())              'Erzeugt String des Messbereichs

VCBereich$ = "   "                       '3 Leerzeichen, wenn undefiniert
IF in%(1) AND 4 THEN VCBereich$ = "DC "  'Byte1, Bit3
IF in%(1) AND 8 THEN VCBereich$ = "AC "  'Byte1, Bit4

END FUNCTION

FUNCTION VCEinheit$ (in%())       'Erzeugt String der Mess-Einheit

E1$ = " "                         'Leerzeichen wenn undefiniert
E2$ = "  "

IF in%(10) AND 2 THEN E1$ = "K"   'Byte10, Bit2
IF in%(10) AND 4 THEN E1$ = "n"   'Byte10, Bit3
IF in%(10) AND 8 THEN E1$ = ""   'Byte10, Bit4
IF in%(11) AND 2 THEN E1$ = "M"   'Byte11, Bit2
IF in%(11) AND 4 THEN E1$ = " "   'Byte11, Bit3
IF in%(11) AND 8 THEN E1$ = "m"   'Byte11, Bit4

IF in%(12) AND 2 THEN E2$ = " "  'Byte12, Bit2
IF in%(12) AND 4 THEN E2$ = " "  'Byte12, Bit3
IF in%(12) AND 8 THEN E2$ = "F "  'Byte12, Bit4
IF in%(13) AND 2 THEN E2$ = "Hz"  'Byte13, Bit2
IF in%(13) AND 4 THEN E2$ = "V "  'Byte13, Bit3
IF in%(13) AND 8 THEN E2$ = "A "  'Byte13, Bit4
IF in%(14) AND 2 THEN E2$ = "HF"  'Byte14, Bit2
IF in%(14) AND 4 THEN E2$ = "C"  'Byte14, Bit3

VCEinheit$ = E1$ + E2$            'Teilstrings zusammensetzen

END FUNCTION

FUNCTION VCWert! (in%())
'Erzeugt aus 4 Bytepaaren mit Hilfe der FUNCTION Ziffer% 4 Ziffern und
'wertet Komma- und Vorzeichenbits aus. Ergebnis ist eine Realzahl, die
'den Messwert enthaelt

 '* Erste Ziffer  (Byte2, Bit1-3; Byte3, Bit1-4):
 Tmp = VCZiffer(in(2), in(3))
 IF Tmp < 0 THEN VCWert! = 9999: EXIT FUNCTION
 Zahl = Zahl + Tmp * 1000
 '* Zweite Ziffer (Byte4, Bit1-3; Byte5, Bit1-4):
 Tmp = VCZiffer(in(4), in(5))
 IF Tmp < 0 THEN VCWert! = 9999: EXIT FUNCTION
 Zahl = Zahl + Tmp * 100
 '* Dritte Ziffer (Byte6, Bit1-3; Byte7, Bit1-4):
 Tmp = VCZiffer(in(6), in(7))
 IF Tmp < 0 THEN VCWert! = 9999: EXIT FUNCTION
 Zahl = Zahl + Tmp * 10
 'Vierte Ziffer (Byte8, Bit1-3; Byte9, Bit1-4):
 Tmp = VCZiffer(in(8), in(9))
 IF Tmp < 0 THEN VCWert! = 9999: EXIT FUNCTION
 Zahl = Zahl + Tmp

 'VCWert! = 9999 wenn Ziffer ungueltig

 'Vorzeichen (Byte2, Bit4):
 IF in(2) AND 8 THEN Vorz = -1 ELSE Vorz = 1
 'Kommastelle:
 Div = 1                         'wenn kein Komma, sonst...
 IF in(8) AND 8 THEN Div = 10    'Komma zwischen Ziffer 3+4 (Byte8, Bit4)
 IF in(6) AND 8 THEN Div = 100   'Komma zwischen Ziffer 2+3 (Byte6, Bit4)
 IF in(4) AND 8 THEN Div = 1000  'Komma zwischen Ziffer 1+2 (Byte4, Bit4)

 VCWert! = Zahl / Div * Vorz       'Messwert errechnen

END FUNCTION

FUNCTION VCZiffer% (Byte1, Byte2)
'Erzeugt aus 3 niederwertigen Bits vom ersten Byte und 4 niederwertigen Bits
'vom zweiten Byte einen 7-Bit-Wert, der einer Ziffer zugeordnet wird.

 DreiBit = Byte1 MOD 8              'obere 5 Bit loeschen
 VierBit = Byte2 MOD 16             'obere 4 Bit loeschen
 SiebenBit = DreiBit + VierBit * 8  '7 Bit Wert erzeugen

                            '   Sieben-Segment-Anzeige
                            '
                            '            Bit0(1)
SELECT CASE SiebenBit       '
 CASE 111: VCZiffer = 0
 CASE 40: VCZiffer = 1      '           XXX 1 XXX
 CASE 93: VCZiffer = 2      '          X         X
 CASE 121: VCZiffer = 3     ' Bit1(2)  6         2  Bit3(8)
 CASE 58: VCZiffer = 4      '          X   Bit4  X
 CASE 115: VCZiffer = 5     '           XXX 7 XXX
 CASE 119: VCZiffer = 6     '          X   (16)  X
 CASE 41: VCZiffer = 7      ' Bit2(4)  5         3  Bit5(32)
 CASE 127: VCZiffer = 8     '          X         X
 CASE 123: VCZiffer = 9     '           XXX 4 XXX
 CASE ELSE: VCZiffer = -1   '
END SELECT                  '            Bit6(64)

'-1 = ungueltige Ziffer

END FUNCTION

SUB WarteAuf (TT)
'SUB wird mit "WarteAuf 0" initialisiert
'bei erneutem Aufruf wird gewartet, bis die bergebe Anzahl Timer-Ticks
'(max 255 zu je 0,055 Sek) seit "WarteAuf 0" vergangen ist.

STATIC Start
STATIC Uebertr
STATIC DMax

DEF SEG = 0

IF TT = 0 THEN                             '0=Kennzahl fr Initialisierung
 Start = PEEK(&H46C)
 Uebertr = PEEK(&H46D) + PEEK(&H46E)
 DMax = 255
 IF PEEK(&H46E) = 24 THEN DMax = 175       'ab 25:59:50 - 0:00:00 = 175 Tics
END IF

IF TT > 0 THEN
 DO
  IF (PEEK(&H46D) + PEEK(&H46E)) <> Uebertr THEN Start = Start - DMax
 LOOP UNTIL PEEK(&H46C) - Start > TT
END IF


END SUB

SUB WertInDatei (Einheit$)

STATIC Datum0$

IF ZBasis$ = "U" THEN
  PRINT #2, UhrZeit$; CHR$(9); LTRIM$(STR$(Wert!));
  IF DATE$ <> Datum0$ THEN
    PRINT #2, " ; "; Datum$
   ELSE
    PRINT #2,
  END IF
  Datum0$ = DATE$
 ELSE
  PRINT #2, LTRIM$(STR$(Seku&)); CHR$(9); LTRIM$(STR$(Wert!))
END IF

END SUB

FUNCTION XVal! (A$)
 'Dezimalkomma in Dezimalpunkt wandeln
 X = INSTR(A$, ",")
 IF X > 0 THEN MID$(A$, X, 1) = "."
 XVal = VAL(A$)
END FUNCTION

SUB Zeitmess (T1&)

STATIC TAlt&, Tage&    'Timerstand vom vorherigen Aufruf und
                       'Sekunden fuer vergangene Tage festhalten

TJetzt& = Tmr&         'aktuellen Timerstand holen
UhrZeit$ = TIME$       'aktuelle Uhrzeit holen

'Tageswechsel zu Mitternacht auswerten (24 Std = 86400 Sek)
IF TJetzt& < TAlt& THEN Tage& = Tage& + 86400

TAlt& = TJetzt&        'Timerstand vom vorherigen Aufruf

'Messzeit in Sekunden errechnen:
Seku& = TJetzt& - T1& + Tage&

END SUB

